function x=linsolveUT( A, b)
	b=b';
	n=length(b);
	x=zeros(1,n);
	x(n)=b(n)/A(n,n);
	for k=n-1:-1:1
		x(k) = (b(k)-sum(A(k,k+1:n).*x(k+1:n)))/A(k,k);
	end
	x=x';
end

function x=linsolveLT( A, b)
	b=b';
	n=length(b);
	x=zeros(1,n);
	x(1)=b(1)/A(1,1);
	for k=2:n
		x(k) = (b(k)-sum(A(k,1:k-1).*x(1:k-1)))/A(k,k);
	end
	x=x';
end




% Natuerlich:  f''(links)=f''(rechts)=0 wenn x und y gleichgross
% Feste Steigung f'(links)=y(1), f'(rechts)=y(length(y)) wenn length(y)=length(x)+2
function coef = spline(x,y) 
%% usage:
%% Cubic splines for data points x/y. coef is a piecewise polynomial.
%% $L{ppval,interp1,interp2,splinefit}
	n = length(x);
	sl = 0;
	if (length(y) == length(x))
		a = y;
	else
		if (length(y) == length(x)+2)
			a = y(2:length(y)-1);
			sl = 1;
		else
			error("length x and length y don't match.");
		end
	end

	h = x(2:n)  - x(1:n-1); 
	Q1 = diag(h(2:n-2));
	Q = diag(2*(h(1:n-2)+h(2:n-1)));
	Q(1:n-3,2:n-2)=Q(1:n-3,2:n-2)+Q1;
	Q(2:n-2,1:n-3)=Q(2:n-2,1:n-3)+Q1;
	if sl
		Q(1,1) = Q(1,1)-h(1)/2;
		Q(n-2,n-2) = Q(n-2,n-2)-h(n-1)/2;
	end

	r = 3*((a(3:n)-a(2:n-1))./h(2:n-1)-(a(2:n-1)-a(1:n-2))./h(1:n-2));
	cl= chol(sparse(Q),r)';
	if sl
		bs = y(1);
		r(1) = r(1)-1.5*((a(2)-a(1))/h(1)-bs);
		bs = y(length(y));
		r(n-2) = r(n-2)+1.5*((a(n)-a(n-1))/h(n-1)-bs);
	end

	c =zeros(n,1); c(2:n-1,1)=cl;
	if sl
		c(1) = -c(2)/2+3/(2*h(1))*((a(2)-a(1))/h(1)-y(1));
		c(n) = -c(n-1)/2-3/(2*h(n-1))*((a(n)-a(n-1))/h(n-1)-y(length(y)));
	end
	a = a';
	d = (c(2:n,1)  - c(1:n-1,1))./(3*h)'; 
	b = (a(2:n,1)  - a(1:n-1,1))./h(1:n-1)'  - (2*c(1:n-1,1)+c(2:n,1))/3 .*h(1:n-1)'; 
	c = c(1:n-1,1); 
	a = a(1:n-1,1); 
	coef = [d,c,b,a,x(1:n-1)'];
end
