 function [I,x,y,z]=createcube()
 	sq3 = sqrt(3);
	x=[-1,-1,-1,-1,1,1,1,1]/sq3;
	y=[-1,-1,1,1,-1,-1,1,1]/sq3;
	z=[-1,1,-1,1,-1,1,-1,1]/sq3;
	I=[8,3,7;3,8,4;6,1,5;1,6,2;
	   8,5,7;5,8,6;4,1,3;1,4,2;
	   8,2,6;2,8,4;7,1,5;1,7,3];
end

function mid = getmid(a,b,x,y,z)
	mx = (x(a)+x(b))/2;
	my = (y(a)+y(b))/2;
	mz = (z(a)+z(b))/2;
	mid = [mx,my,mz]/sqrt(mx*mx+my*my+mz*mz);
end

function r = sorttri(t,x,y,z)
	a=t(1);b=t(2);c=t(3);
	A=[x(a)-x(c),y(a)-y(c),z(a)-z(c)];
	B=[x(b)-x(c),y(b)-y(c),z(b)-z(c)];
	C=[x(c),y(c),z(c)];
	g=cross(A,B)*C';
	if(g<0)
		r=[b,a,c];
	else
		r=t;
	end
end

function r=sorttris(I,x,y,z)
	for i=1:size(I)(1)
		I(i,1:3)=sorttri(I(i,:),x,y,z);
	end
	r=0;
end
		

function [I,x,y,z]=subdivide(I0,x0,y0,z0)
	x=x0;
	y=y0;
	z=z0;
	I=0;
	for i=1:size(I0)(1)
		t = I0(i,:); % previous triangle
		mid = getmid(t(1),t(2),x,y,z);
		n = length(x);
		x(n+1) = mid(1);
		y(n+1) = mid(2);
		z(n+1) = mid(3);
		I(2*i-1,1:3) = [t(1), t(3), n+1];
		I(2*i,1:3)   = [t(2), t(3), n+1];
	end
end

function [I,x,y,z]=trisphere(n)
%% usage:
%% 
%% Triangulation of spheresurface. Starting with a cubesurface (n=0)
%% each iteration n doubles the number of triangles. x,y,z are coordiante
%% values, I is a Nx3 matrix specifying indices of triangle points.
%% $X{
%% >> [I,x,y,z]=trisphere(4);
%% >> trisurf(I,x,y,z,'g')
%% >> set("light",[0.8,0.8,0.8])
%% >> set("outline",0)
%% }
%% $I{trisurf.png}
%% $L{trimesh,trisurf}

	[I,x,y,z]=createcube();
	while n-->0
		[I,x,y,z] = subdivide(I,x,y,z);
	end
	sorttris(I,x,y,z);
end